HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394

~~~~

早起一发线段树,开心又快乐。这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧。

~~~~

大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数。

首先介绍下逆序数的概念:

在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面的数,那末它们就称为一个逆序。

一个排列中逆序的总数就称为这个排列的逆序数。逆序数为偶数的排列称为偶排列;逆序数为奇数的排列称为奇排列。

同时求解逆序数有个小公式:

a[0]后边有a[0]个比a[0]小的数(想想为什么),将a[0]移到末尾时,a[0]的逆序数变成n-1-a[0];

而a[0]个比a[0]小的数的逆序数都减1,设原序列的逆序数为sum,则新序列的逆序数sum=sum-a[0]+n-1-a[0];

~~~~

#include<cstdio>
#include<algorithm>
#include<cstring>
#define lson rt<<1,s,mid
#define rson rt<<1|1,mid+1,e
#define N 5000+100
using namespace std;

int tre[N<<2];
void pushup(int rt)
{
    tre[rt]=tre[rt<<1]+tre[rt<<1|1];
}
void build(int rt,int s,int e)
{
    tre[rt]=0;
    if(s==e)
        return ;
    int mid=(s+e)>>1;
    build(lson);
    build(rson);
}
int query(int l,int r,int rt,int s,int e)
{
    if(l==s && r==e)
        return tre[rt];
    int mid=(s+e)>>1;
    if(r<=mid) return query(l,r,lson);
    else if(l>mid) return query(l,r,rson);
    else return query(l,mid,lson)+query(mid+1,r,rson);
}
void update(int pos,int rt,int s,int e)
{
    if(s==e)
    {
        tre[rt]++;
        return ;
    }
    int mid=(s+e)>>1;
    if(pos<=mid) update(pos,lson);
    else update(pos,rson);
    pushup(rt); //更新。
}

int n,a[N];
int main()
{
    while(scanf("%d",&n)==1)
    {
        int tot=0;
        build(1,0,n-1);
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
            tot+=query(a[i],n-1,1,0,n-1);   //线段树求解a[i]之前的逆序数。
            update(a[i],1,0,n-1);   //更新,也就是把a[i]压入线段树。
        }
        //printf("%d\n",tot);
        int ans=tot;
        for(int i=0;i<n;i++)
        {
            tot=tot+(n-1-a[i])-a[i];    //相当于依次把第i个数放到a[0]的位置
            ans=min(ans,tot);
        }
        printf("%d\n",ans);
    }
    return 0;
}

~~~~

暴力解法。····

#include<cstdio>
#include<algorithm>
#include<cstring>
#define N 5000+100
#define INF 0x3f3f3f3f
using namespace std;

int n;
int a[N],b[N];

int qyj()
{
    int tot=0;
    for(int i=0;i<n-1;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            if(a[i]>a[j])
                tot++;
        }
    }
    return tot;
}

int main()
{
    while(scanf("%d",&n)==1)
    {
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        int tot=qyj(),ans=tot;
        for(int i=0;i<n;i++)
        {
            tot=tot+(n-1-a[i])-a[i];
            ans=min(ans,tot);
        }
        printf("%d\n",ans);
    }
    return 520;
}

HDU 1394 Minimum Inversion Number.(线段树)

时间: 2024-09-30 06:37:53

HDU 1394 Minimum Inversion Number.(线段树)的相关文章

hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新 // // 典型线段树的单点更新 // // 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序 // 求出最初始的逆序数,然后按照公式递推,结果就呵呵了 // // 发现大牛都是用线段树和树状数组之类的做的,而自己又在学 // 线段树,所以就敲了线段树. // // 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个. // 因为每个数是0,1,2...n-1且没有重复的数字. /

HDU 1394 Minimum Inversion Number (线段树,单点更新)

C - Minimum Inversion Number Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Appoint description: System Crawler (2015-08-17) Description The inversio

Hdu 1394 Minimum Inversion Number(线段树或树状数组)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11981    Accepted Submission(s): 7321 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (线段树,暴力)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

hdu - 1394 Minimum Inversion Number(线段树水题)

http://acm.hdu.edu.cn/showproblem.php?pid=1394 很基础的线段树. 先查询在更新,如果后面的数比前面的数小肯定会查询到前面已经更新过的值,这时候返回的sum就是当前数的逆序数. 这样查询完之后得到初始数列的逆序数,要求得所有序列的最小逆序数,还需要循环一次. 设初始序列abcde中逆序数为k,小于a的个数是t-1那么大于a的个数就是n-t,当把a左移一位,原来比a大的都变成了a的逆序对,即逆序数增加了n-t,但是原来比a小的数都变成了顺序, 因此逆序数

hdu 1394 Minimum Inversion Number 线段树

Problem Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of

hdu 1394 Minimum Inversion Number (裸树状数组 求逆序数)

题目链接 题意: 给一个n个数的序列a1, a2, ..., an ,这些数的范围是0-n-1, 可以把前面m个数移动到后面去,形成新序列:a1, a2, ..., an-1, an (where m = 0 - the initial seqence)a2, a3, ..., an, a1 (where m = 1)a3, a4, ..., an, a1, a2 (where m = 2)...an, a1, a2, ..., an-1 (where m = n-1)求这些序列中,逆序数最少的

HDU 1394 Minimum Inversion Number(树状数组||线段树)

题目链接:点击打开链接 对于求逆序数的问题, 通常用线段树或者树状数组来维护, 树状数组代码短,好写, 还是尽量写树状数组吧. 首先求出原始排列的逆序数,  那么对于每一次操作, 因为都是将当前排列的第一个数拿到最后一个位置, 所以答案就增加了所有比他大的数字个数,减小了所有比他小的数字个数. 细节参见代码: #include<cstdio> #include<cstring> #include<algorithm> #include<iostream> #

hdu 1394 Minimum Inversion Number(树状数组)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 题意:给你一个0 — n-1的排列,对于这个排列你可以将第一个元素放到最后一个,问你可能得到的最多逆序对的个数 求出原始序列的逆序对的数目,然后进行n-1次将第一个元素放到最后一个的操作,每次操作后可以用O(1)复杂度求得新序列的逆序对数目 此题的关键点在于求出原始序列逆序对的数目,可以使用树状数组, 线段树, 归并等方法. 下面是树状数组的解法 #include <iostream> #i